# Contributing to [Sorter](http://github.com/giantas/sorter)

Thank you, for taking your time to contribute. :+1:

The following is a set of guidelines for contributing to [Sorter](http://github.com/giantas/sorter) and its components. These are mostly guidelines, not rules. Use your best judgment.

#### Table Of Contents

[Code of Conduct](#code-of-conduct)

[How Can I Contribute?](#how-can-i-contribute)
  * [Reporting Bugs](#reporting-bugs)
  * [Suggesting Enhancements](#suggesting-enhancements)
  * [Code Contribution](#code-contribution)

[Style Guides](#style-guides)
  * [Git Commit Messages](#git-commit-messages)
  * [Python Style Guide](#python-style-guide)

[Miscellaneous](#miscellaneous)

## Code of Conduct

This project and its participants are governed by a [Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Any unacceptable behavior shall not be tolerated.

## How Can I Contribute?

### Reporting Bugs

This section guides you through submitting a bug report for Sorter. Following these guidelines helps maintainers and the community understand your report, reproduce the behavior, and find related reports.

Bugs and issues are reported [here](https://github.com/giantas/sorter/issues). Before reporting a bug, please [check](https://github.com/giantas/sorter/issues) that it has not yet been reported. Be sure to assign the **bug** label to your issue. Kindly include as much detail as you can while reporting the bug, including details about your environment such as:

* **Which version of Sorter you are using**? You can get the exact version by checking Help > About.
* **What's the name and version of the OS you're using**?
* **Is your OS x86 or x64, or other**? Include as much details as possible.

> **Note:** If you find a **Closed** issue that seems similar to what you are experiencing, open a new issue and include a link to the original issue in the body of your new one.

### Suggesting Enhancements

This section guides you through submitting an enhancement suggestion for Sorter, including completely new features and minor improvements to existing functionality. Following these guidelines helps maintainers and the community understand your suggestion and find related suggestions.

Enhancement suggestions are reported [here](https://github.com/giantas/sorter/issues). Before creating an enhancement suggestion, please check that you are using the [latest](https://github.com/giantas/sorter/releases/latest) version of Sorter. Also [check](https://github.com/giantas/sorter/issues) that your suggestion has not yet been made. If it has, add a comment, or a note, to the existing issue. Be sure to assign the **enhancement** label to your issue and include as much detail as possible.

### Code Contribution

Before making changes to this repository, check that the [development](https://github.com/giantas/sorter/tree/development) branch does not feature your enhancements.

**Recommended:** Go through the [style guides](#style-guides) before proceeding.

1. Fork [this repository](https://github.com/giantas/sorter) to make your own copy of this project.
2. Checkout from the [development](https://github.com/giantas/sorter/tree/development) branch.
3. Make your changes to the projects.
4. Create tests for your changes.
5. Merge to the [development](https://github.com/giantas/sorter/tree/development) branch.
6. Submit a pull request on your proposed changes. Include full and comprehensive details on your changes.

## Style Guides

### Git Commit Messages

Know how to write [good commit messages](https://github.com/erlang/otp/wiki/Writing-good-commit-messages).

* Use the present tense ("Add feature" not "Added feature")
* Use the imperative mood ("Move cursor to..." not "Moves cursor to...")
* Limit the first line to 50 characters or less
* Reference issues and pull requests liberally after the first line

### Python Style Guide

Use 4 spaces, **NOT** tabs.

## Miscellaneous

Please open an issue if you have further suggestions for this document and/or the [Code of Conduct](CODE_OF_CONDUCT.md)
